# -*- mode: rpm-spec; -*-
#### CAUTION: "samples" sub-package can be built only if "opensoap"
#### and "opensoap-devel" are already installed.  Please comment out
#### the samples parts and build other packages first if any binaries
#### are not available on your target system.

%define orig_version 1.0-20030331

%define _with_cgi_bin /var/www/cgi-bin
#define _with_cgi_bin /home/httpd/cgi-bin

%define _sysconfdir /etc/opensoap
%define _with_servicesdir /usr/lib/opensoap

%define _localstatedir /var/opensoap
# may need to be modified like /var/{log,spool,run}/opensoap

Summary: SOAP-based middleware for XML Web Services applications.
Summary(ja): XML WebӥץꥱSOAP١ߥɥ륦
Name: opensoap
Version: 1.0_20030331
Release: 2
Group: System Environment/Libraries
Group(ja): ƥĶ/饤֥
#without samples# BuildRequires: libxml2-devel, openssl-devel
#### samples can be built only if opensoap-devel is already installed.
BuildRequires: libxml2-devel, openssl-devel opensoap-devel
#### samples ####
Requires: libxml2, openssl
Source: www.opensoap.jp:/download/%{name}-%{orig_version}.tar.gz
Copyright: BSD
URL: http://www.opensoap.jp/
BuildRoot: %{_tmppath}/%{name}-buildroot
#Patch: %{name}-%{orig_version}.patch

%description
OpenSOAP provides an environment for XML Web Services.
API libraries to use SOAP (Simple Object Access Protocol) and the
server for service applications are provided.  Also Transaction and
Security functions are implemented.
This main package includes shared libraries for executing OpenSOAP
application software, and such basic tools as Soaping client/service
and Transaction service.

%description -l ja
OpenSOAPXML WebӥΤδĶ󶡤ޤSOAP (Simple Object
Access Protocol)Ѥ뤿API饤֥ȡӥץꥱ
ѤΤΥФ󶡤ȥ󥶥䥻ƥεǽ
Ƥޤ
ΥѥåˤϡOpenSOAPץꥱ󥽥եȼ¹Իɬפ
ͭ饤֥ꡢڤӡܥġǤSoaping饤/ӥ
Transactionӥޤޤޤ

%package devel
Summary: Libraries, include files to develop OpenSOAP applications.
Summary(ja): OpenSOAPץꥱȯΤΥ饤֥ȥإåե롣
Group: Development/Libraries
Group(ja): ȯ/饤֥
Requires: %{name} = %{version}

%description devel
Libraries, include-header files and documentation which can be used to
develop software based on SOAP for Web Services, and to compile the
source code for OpenSOAP application programs.

%description devel -l ja
Υ饤֥ȥإåե롢ڤӥɥѤ뤳Ȥǡ
WebӥΤSOAP̿Ѥ륽եȥȯꡢꤷ
OpenSOAPץꥱΥɤ򥳥ѥڤӥ󥯤뤳
ǽȤʤޤ

%package server
Summary: Server for the original OpenSOAP functions.
Summary(ja): OpenSOAPȼεǽ¸뤿ΥС
Group: System Environment/Daemons
Group(ja): ƥĶ/ǡ
Requires: %{name} = %{version}

%description server
The OpenSOAP Server supports operations for Web Service systems and
provides practical functions, such as asynchronous client connections
for non-real time processing, message forwarding for searching valid
services and passing through firewalls, and signing messages for
security validation.

%description server -l ja
OpenSOAPФϡ絬ϤWebӥƥαѤ򥵥ݡȤޤ
ӥꥢ륿бƱ饤³ǽ
õեۤ¸륵д֥åžǽ
ؤν̾ʤɤԤƥǽޤޤƤޤ

#### samples can be built only if opensoap-devel is already installed.
%package samples
Summary: Sample application programs of OpenSOAP.
Summary(ja): OpenSOAPΥץ륢ץꥱץࡣ
Group: Applications/Networking
Group(ja): ץꥱ/ͥåȥ
Requires: %{name} = %{version}

%description samples
This is a collection of simple sample application programs using
OpenSOAP.  Please try them if you just want to use OpenSOAP.  If you
are interested in developing application programs, please also refer
to the source codes.

%description samples -l ja
OpenSOAPץꥱδñʥץδ󤻽Ǥ
OpenSOAPȤꤢȤäƤߤˡ󤪻ץꥱ
ץ೫ȯ˶̣Τϡɤ⤴
#### samples ####

%prep
%setup -q -n %{name}-%{orig_version}
#%patch -p1

rm -rf $RPM_BUILD_ROOT

%build
%configure --sysconfdir=%{_sysconfdir} --with-servicesdir=%{_with_servicesdir} --with-cgi-bin=%{_with_cgi_bin} --localstatedir=%{_localstatedir}

cp -pr doc docs
find docs -name 'Makefile*' -exec rm {} \;
rm -rf docs/api/*/Doxyfile
rm -rf docs/api/*/text/
cp -pr samples docs/

make
#### samples can be built only if opensoap-devel is already installed.
(cd samples ; make clean-samples ; make all-samples)
#### samples ####

%install
make DESTDIR="$RPM_BUILD_ROOT" install
#### samples can be built only if opensoap-devel is already installed.
(cd samples ; make DESTDIR="$RPM_BUILD_ROOT" install-samples)
#### samples ####

%clean
rm -rf $RPM_BUILD_ROOT

%preun server
if [ $1 = 0 ]; then
	%{_sbindir}/opensoap-server-ctl stop || exit 0
fi

%post -p /sbin/ldconfig
%postun -p /sbin/ldconfig

%files
%defattr(-,root,root)

%{_bindir}/soaping
%{_libdir}/libOpenSOAPClient.so.*
%{_libdir}/libOpenSOAPService.so.*
%{_libdir}/libOpenSOAPSecurity.so.*
%{_with_cgi_bin}/TransactionService.cgi
%{_with_cgi_bin}/SoapingService.cgi
%{_with_servicesdir}/Soaping
%{_with_servicesdir}/Transaction
%{_localstatedir}/services/Transaction
%{_mandir}/man1/*
%doc INSTALL INSTALL.ujis README README.ujis LICENSE
%doc HISTORY HISTORY.ujis TODO TODO.ujis
%doc docs/tools

%files devel
%defattr(-,root,root)

%{_includedir}/OpenSOAP
%{_libdir}/libOpenSOAPClient.so
%{_libdir}/libOpenSOAPService.so
%{_libdir}/libOpenSOAPSecurity.so
%{_libdir}/libOpenSOAPClient.*a
%{_libdir}/libOpenSOAPService.*a
%{_libdir}/libOpenSOAPSecurity.*a
%doc docs/api/en
%doc docs/api/ja
%doc docs/security
#%doc docs/java

%files server
%defattr(-,root,root)

%{_sbindir}/*
%{_libdir}/libOpenSOAPServer.*
%{_libdir}/libHTTPMessage.*
%{_libdir}/libSOAPMessage.*
%{_libdir}/libconnection.*
%config %{_sysconfdir}/server.conf
%config %{_sysconfdir}/privKey.pem
%config %{_sysconfdir}/pubKey.pem
%{_sysconfdir}/*pem.default
%{_sysconfdir}/ssml/Soaping.ssml
%{_sysconfdir}/ssml/Transaction.ssml
%{_with_cgi_bin}/soapInterface.cgi
%{_mandir}/man8/*
%doc docs/server/*

#### samples can be built only if opensoap-devel is already installed.
%files samples
%defattr(-,root,root)

%doc docs/samples/*
%{_with_cgi_bin}/*Calc*
%{_with_cgi_bin}/Hello*
%{_with_cgi_bin}/GetCertService.cgi
%{_with_cgi_bin}/*Shopping*
%{_with_cgi_bin}/TransactionApp.cgi
%{_with_cgi_bin}/TransactionHtml
%{_with_cgi_bin}/TransactionABankService.cgi
%{_with_servicesdir}/*Calc*
%{_with_servicesdir}/*Hello*
%{_with_servicesdir}/GetCert
%{_with_servicesdir}/*Shopping*
%{_with_servicesdir}/TransactionABank
%{_bindir}/*Calc*
%{_bindir}/*Hello*
%{_bindir}/GetCertClient
%{_bindir}/registCA
%{_bindir}/genrsakey
%{_bindir}/secEnv
%{_bindir}/*Shopping*
%{_bindir}/TransactionClient
%{_sysconfdir}/ssml/*Calc*
%{_sysconfdir}/ssml/GetCert.ssml
%{_sysconfdir}/ssml/*Hello*
%{_sysconfdir}/ssml/*Shopping*
%{_sysconfdir}/ssml/TransactionABank.ssml
%{_localstatedir}/services/CalcAsync
%{_localstatedir}/services/GetCert
%{_localstatedir}/services/ShoppingSec
#### samples ####

%changelog
* Sat Mar  1 2003 Nobuhito OKADA <okada@opensoap.jp>
- 1.0_20030228-2
- added %defattr
- removed Vendor
- corrected _with_cgi_bin (bug of define ?)

* Thu Feb 28 2003 Nobuhito OKADA <okada@opensoap.jp>
- 1.0_20030228-1
- Released as the first version.
