/*-----------------------------------------------------------------------------
 * $RCSfile: regist.c,v $
 *
 * See Copyright for the status of this software.
 *
 * The OpenSOAP Project
 * http://opensoap.jp/
 *-----------------------------------------------------------------------------
 */
#include <stdio.h>
#include <string.h>
#include <OpenSOAP/Security.h>

/***************************************************************************** 
    Function      : gp@̕\
    Return        : void
 ************************************************ Yuji Yamawaki 02.03.12 *****/
static void usage
(const char* szProg)
{
    fprintf(stderr, "Usage: %s RegistFileName\n", szProg);
}
/***************************************************************************** 
    Function      : C
    Return        : int(0: No Error, Others: Error)
 ************************************************ Yuji Yamawaki 02.03.12 *****/
static int procMain
(const char* szFile) /* (i)  o^pt@C */
{
    int   nRet = OPENSOAP_NO_ERROR;
    FILE* fp   = NULL;
    char  szName[OPENSOAP_CA_OWNER_LEN + 1];
    char  szDate[OPENSOAP_CERT_DATE_LEN + 2];
    int   nLen;
    unsigned long  ulLenKey;
    unsigned char* pucKey = NULL;
    unsigned long  ulSereal;

    /* o^pt@CI[v */
    /* Ps:LҖ,Qs:L,Rsڈȍ~:J ŁALq    */
    fp = fopen(szFile, "rt");
    if (fp == NULL) {
        fprintf(stderr, "Cannot Open File[%s].\n", szFile);
        nRet = 1;
        goto FuncEnd;
    }
    /* o^ */
    for  (;;) {
        /* LҖ */
        if (fgets(szName, sizeof(szName), fp) == NULL) {
            break;
        }
        nLen = strlen(szName);
        if (nLen <= 1) {
            continue;  // sXLbv
        }
        szName[nLen - 1] = '\0';
        /* t */
        if (fgets(szDate, sizeof(szDate), fp) == NULL) {
            break;
        }
        nLen = strlen(szDate);
        if (nLen != OPENSOAP_CERT_DATE_LEN + 1) {
            /* 񒷕s(s܂ōl) */
            break;
        }
        szDate[nLen - 1] = '\0';
        /* J(fR[h) */
        nRet = OpenSOAPSecDecodeKeyFile(fp, &ulLenKey, &pucKey);
        if (OPENSOAP_FAILED(nRet)) {
            fprintf(stderr, "OpenSOAPSecDecodeKeyFile() Error[0x%08x]. \n",
                    (unsigned int)nRet);
            goto FuncEnd;
        }
        /* o^ */
        nRet = OpenSOAPSecCARegist(szName, szDate, ulLenKey, pucKey,
                                   &ulSereal);
        if (OPENSOAP_FAILED(nRet)) {
            fprintf(stderr, "OpenSOAPSecCARegist() Error[0x%08x]. \n",
                    (unsigned int)nRet);
            goto FuncEnd;
        }
        fprintf(stderr, "Regist OK. Serial:%lu\n", ulSereal);
        /* ォÂ */
        if (pucKey != NULL) {
            free(pucKey);
            pucKey = NULL;
        }
    }
FuncEnd:
    if (fp != NULL) {
        fclose(fp);
    }
    if (pucKey != NULL) {
        free(pucKey);
    }
    return nRet;
}
/***************************************************************************** 
    Function      : C
    Return        : int
 ************************************************ Yuji Yamawaki 02.03.12 *****/
int main(int argc, char* argv[])
{
    int nRet = 0;
    /* ̐`FbN */
    if (argc < 2) {
        usage(argv[0]);
        nRet = 1;
        goto FuncEnd;
    }
    /* s */
    nRet = procMain(argv[1]);
    /* ʕ\ */
    nRet = OpenSOAPSecCABrowse(stdout);
    if (OPENSOAP_FAILED(nRet)) {
        fprintf(stderr, "OpenSOAPSecCABrowse() Error[0x%08x]. \n",
                (unsigned int)nRet);
        goto FuncEnd;
    }
FuncEnd:
    return nRet;
}
